#include <iostream>

using namespace std;
int n,k,x,br=0,j=0,p=0;
int niz [1000000];
int pniz[1000000];
int main()
{
  cin>>n;
  cin>>k;
  for(int i=0;i<2*n+1;i++)
  {
      niz[i]=0;
      pniz[i]=0;
  }
 for(int i=0;i<n;i++)
  {
      cin>>x;
      if(x<0)
        x=n-x;
      niz[x]++;
  }

  for(int i=0;i<2*n+1;i++)
  {
      if(niz[i]>=k)
      {
          br++;
          if(i>n)
          {
              p=n-i;
          }
          else
            p=i;
          pniz[j]=p;
          j++;
      }
  }

   cout<<br<<"\n";
   j=0;
   for(j=0;j<br;j++)
   {
       cout<<pniz[j]<<" ";
   }

}